



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python脚本控制的WebDriver 常用操作 &lt;十二&gt; send_keys模拟按键输入</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python脚本控制的WebDriver 常用操作 &lt;十二&gt; send_keys模拟按键输入</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 09:05:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>下面将使用WebDriver中的send_keys来模拟键盘按键输入</p>
<h1>测试用例场景</h1>
<hr />
<p>　　send_keys方法可以模拟一些组合键操作：</p>
<ul><li>ctrl+a</li>
<li>ctrl+c</li>
<li>ctrl+v</li>
<li>等。</li></ul>
<p>　　另外有时候我们需要在测试时使用tab键将焦点转移到下一个元素，这时候也需要send_keys。在某些更复杂的情况下，还会出现使用send_keys来模拟上下键来操作下拉列表的情况。</p>
<h1>Python脚本</h1>
<hr />
<p>测试HTML代码：</p>
<div>
<pre class="prettyprint linenums">    &lt;html&gt;
        &lt;head&gt;
            &lt;meta http-equiv="content-type" content="text/html;charset=utf-8" /&gt;
            &lt;title&gt;send keys&lt;/title&gt;
            &lt;script type="text/javascript" async="" src="http://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"&gt;&lt;/script&gt;
            &lt;link href="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/css/bootstrap-combined.min.css" rel="stylesheet" /&gt;
        &lt;/head&gt;
        &lt;body&gt;
            &lt;h3&gt;send keys&lt;/h3&gt;
            &lt;div class="row-fluid"&gt;
            &lt;div class="span3"&gt;
                &lt;div class="well"&gt;
                    &lt;label&gt;A&lt;/label&gt;
                    &lt;textarea rows="10", cols="10" id="A"&gt;I think watir-webdriver is better than selenium-webdriver&lt;/textarea&gt;
                &lt;/div&gt;
            &lt;/div&gt;
            &lt;div class="span3"&gt;
                &lt;div class="well"&gt;
                    &lt;label&gt;B&lt;/label&gt;
                    &lt;textarea rows="10", cols="10" id="B"&gt;&lt;/textarea&gt;
                &lt;/div&gt;
            &lt;/div&gt;
            &lt;/div&gt;
        &lt;/body&gt;
     &lt;script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"&gt;&lt;/script&gt;
    &lt;/html&gt;</pre>
</div>
<p>测试Python代码：</p>
<div>
<pre class="prettyprint linenums">from selenium import webdriver
from selenium.webdriver.common.keys import Keys
from time import sleep
import os
if 'HTTP_PROXY' in os.environ: del os.environ['HTTP_PROXY']

dr = webdriver.Firefox()
file_path = 'file:///' + os.path.abspath('send_keys.html')
dr.get(file_path)

#todo: copy the content of A
dr.find_element_by_id('A').send_keys((Keys.CONTROL,'a'))
sleep(5)
dr.find_element_by_id('A').send_keys((Keys.CONTROL,'x'))
sleep(5)

#todo:paste content of A to B
dr.find_element_by_id('B').send_keys((Keys.CONTROL,'v'))
sleep(5)

#todo:send keys to A
dr.find_element_by_id('A').send_keys('I', Keys.SPACE,'Love',Keys.SPACE,'AutoTesting')

sleep(5)
dr.quit()</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g7e097.html">kafka性能参数和压力测试揭秘</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8odwzxq.html">jsf初学解决faces 中文输入乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2002x9.html">WPF中实现登陆窗口的&OpenCurlyDoubleQuote;记住帐号&rdquo;功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxrwkdq.html">iOS版本控制git小结－－yoowei</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxrgdjq.html">JS插件之&mdash;&mdash;ztree</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rddvkd8.html">Hadoop集群中添加硬盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdk3j48.html">HGE初始化状态设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmxryl9.html">linux 常见问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm45jx9.html">【转】 基于TFTP协议的远程升级设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z421j9.html">tab奇偶行颜色交替&plus;插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyj2xk9.html">linux 命令&lpar;alias &comma; unalias &comma; install &comma;ar &comma; arch &comma;uname &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jn4mo8.html">Linux内核调优参数说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj0715q.html">Python基础之数据类型、变量、常量</a>
		</li>
						<li><a href="https://www.batexi.com/a/90moj5n8.html">python之动态参数 &ast;args&comma;&ast;&ast;kwargs和命名空间</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kggj09.html">这个表明将http协议转成websocket协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv5drz8.html">margin纵向重叠</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw34zd8.html">Navicat（数据库可视化操作软件）安装、配置、测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jdd2nq.html">alibaba dubbo admin的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1lm7eq.html">maven 下载镜像文件卡，下载pom文件慢的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpm02z9.html">android调节声音大小</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlml6ge9.html">SQL Server设置主键自增长列</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j01w1eq.html">&lbrack;转&rsqb;MFC中UpdateData&lpar;&rpar;函数的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mo6yeq.html">Bug管理工具的使用介绍（Bugger 2016）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd5o5e8.html">IIS7&period;0设置404错误页，返回500状态码</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1jw3j9.html">业务gis 怎么让别的开发人员不需要懂gis就可以搞开发？ （五）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1y5zv9.html">Select的深入应用（2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdlk7l8.html">PNG图片数据解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok4k3x9.html">再看&period;net本质（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1m17e9.html">MVC ckeditor的基本使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xpw409.html">WP8&lowbar;访问ListBox中的Item项中的某个元素</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
